package org.jeecg.modules.weituo.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.jeecg.modules.weituo.entity.ItdmWeituoInfo;

import java.util.List;

/**
 * @Description: 委托信息
 * @Author: jeecg-boot
 * @Date: 2023-05-17
 * @Version: V1.0
 */
public interface ItdmWeituoInfoMapper extends BaseMapper<ItdmWeituoInfo> {


    /**
     * 根据委托单位查询委托信息列表
     */
    @Select("select * from itdm_weituo_info where weituo_client like  '%${weituoClient}%' and shenhe_status =1 ")
    public List<ItdmWeituoInfo> selectWTListByClient(@Param("weituoClient") String weituoClient);


    @Select("select * from itdm_weituo_info where  shenhe_status =1 ")
    public List<ItdmWeituoInfo> selectShenheOk();




    /**
     * 查询委托单位名称（不重复）
     */
    @Select("select distinct weituo_client from itdm_weituo_info")
    public List<String> selectDistinctClientList();

    /**
     * 根据委托查询委托id
     */
    @Select("select id from itdm_weituo_info where weituo_no = #{weituoNo}")
    String selectByWeituoNo(@Param("weituoNo") String weituoNo);

}
