package org.jeecg.modules.weituo.service;

import com.baomidou.mybatisplus.extension.service.IService;
import org.jeecg.modules.weituo.dto.WeituoInsertCommand;
import org.jeecg.modules.weituo.dto.WeituoUpdateCommand;
import org.jeecg.modules.weituo.entity.ItdmWeituoInfo;
import org.jeecg.modules.weituo.entity.ItdmWeituoYangpin;
import org.jeecg.modules.weituo.vo.ItdmWeituoInfoInfoVO;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * @Description: 委托信息
 * @Author: jeecg-boot
 * @Date:   2023-05-17
 * @Version: V1.0
 */
public interface IItdmWeituoInfoService extends IService<ItdmWeituoInfo> {


    /**根据委托单位查询委托信息列表*/
    public List<ItdmWeituoInfo> selectWTListByClient(String weituoClient);


    public List<ItdmWeituoYangpin> selectItdmWeituoYangpinCompany();
    /**查询委托单位名称（不重复）*/
    public List<String> selectDistinctClientList();

    public void saveWeituo(WeituoInsertCommand command);


    public void updateWeituo(WeituoUpdateCommand command);


    ItdmWeituoInfoInfoVO findById(String id);


    void deleteById(String id);
    void deleteByIds(List<String> id);


    public void word(String id, HttpServletResponse response) throws IOException;




    /**根据委托单位查询委托信息列表*/
    public List<ItdmWeituoInfo> shenheList();

}


